#ifndef _DIRTOOLS_
#define _DIRTOOLS_
#include "share.h"
#pragma comment(lib,"ceshell.lib")

class THIDirTools:public TDebug
{
   private:
         void Search(string &Dir);
   
   public:
      string _prop_Source;
      string _prop_Dest;
      string next;
      BYTE flag;
      BYTE au;
      BYTE nc;
      BYTE ncm;
      BYTE ne;
      BYTE rc;
      BYTE sl;
      BYTE sp;
      DWORD hold;
    THI_Event *_data_Source;
    THI_Event *_data_Dest;
    THI_Event *_event_onOK;
    
       void AllowUnDo(bool Value);
    __declspec (property( put = AllowUnDo ))bool _prop_AllowUnDo;
       void NoConfirmation(bool Value);
    __declspec (property( put = NoConfirmation ))bool _prop_NoConfirmation;
       void NoConfirmMKDir(bool Value);
    __declspec (property( put = NoConfirmMKDir ))bool _prop_NoConfirmMKDir;
       void NoErrorUI(bool Value);
    __declspec (property( put = NoErrorUI ))bool _prop_NoErrorUI;
       void RenameOnCollision(bool Value);
    __declspec (property( put = RenameOnCollision ))bool _prop_RenameOnCollision;
       void Silent(bool Value);
    __declspec (property( put = Silent ))bool _prop_Silent; 
       void SimpleProgress(bool Value);
    __declspec (property( put = SimpleProgress ))bool _prop_SimpleProgress;                   
    

    HI_WORK_LOC(THIDirTools,_work_doCopy)
    {
       string d1 = ReadString(_Data,_data_Source,_prop_Source);
       string d2 = ReadString(_Data,_data_Dest,_prop_Dest);
       TCHAR source[_MAX_PATH + 1];
        _tcscpy(source,d1.c_str());
       source[_tcslen(source)+1]=0; 
       string st = L"\\";
       string up;      
         int round=10;
             for(int i = 0; i < round; ++i)
             up = d1.GetTok(st); 
         string d3=d2+st+up; 
       TCHAR dest[_MAX_PATH + 1];
        _tcscpy(dest,d3.c_str());
       dest[_tcslen(dest)+1]=0;                  
             
       SHFILEOPSTRUCT shf;
       ZeroMemory(&shf, sizeof(SHFILEOPSTRUCT));
       shf.hwnd=NULL;
       shf.wFunc=FO_COPY;
       shf.pFrom=source;
       shf.pTo=dest;
       shf.fFlags=BYTE(flag);
        if(SHFileOperation(&shf) == 0)
         _hi_onEvent(_event_onOK );
     }

    HI_WORK_LOC(THIDirTools,_work_doMove)
    {
       string d1 = ReadString(_Data,_data_Source,_prop_Source);
       string d2 = ReadString(_Data,_data_Dest,_prop_Dest); 
       TCHAR source[_MAX_PATH + 1];
        _tcscpy(source,d1.c_str());
       source[_tcslen(source)+1]=0; 
       string st = L"\\";
       string up;      
         int round=10;
             for(int i = 0; i < round; ++i)
             up = d1.GetTok(st); 
         string d3=d2+st+up; 
       TCHAR dest[_MAX_PATH + 1];
        _tcscpy(dest,d3.c_str());
       dest[_tcslen(dest)+1]=0;                  
        
       SHFILEOPSTRUCT shf;
       ZeroMemory(&shf, sizeof(SHFILEOPSTRUCT));
       shf.hwnd=NULL;
       shf.wFunc=FO_MOVE;
       shf.pFrom=source;
       shf.pTo=dest;
       shf.fFlags=BYTE(flag);
        if(SHFileOperation(&shf) == 0)
         _hi_onEvent(_event_onOK );
     } 
     
     HI_WORK_LOC(THIDirTools,_work_doDelete)
    {
       string d1 = ReadString(_Data,_data_Source,_prop_Source);
       TCHAR source[_MAX_PATH + 1];
        _tcscpy(source,d1.c_str());
       source[_tcslen(source)+1]=0; 
       SHFILEOPSTRUCT shf;
       ZeroMemory(&shf, sizeof(SHFILEOPSTRUCT));
       shf.hwnd=NULL;
       shf.wFunc=FO_DELETE;
       shf.pFrom=source;       
       shf.pTo=NULL;
       shf.fFlags=BYTE(flag);
        if(SHFileOperation(&shf) == 0)
         _hi_onEvent(_event_onOK );
     }    
        
     HI_WORK_LOC(THIDirTools,_work_doRename)
    {
       string d1 = ReadString(_Data,_data_Source,_prop_Source);
       string d2 = ReadString(_Data,_data_Dest,_prop_Dest); 
       TCHAR source[_MAX_PATH + 1];
        _tcscpy(source,d1.c_str());
       source[_tcslen(source)+1]=0;  
       TCHAR dest[_MAX_PATH + 1];
        _tcscpy(dest,d2.c_str());
       dest[_tcslen(dest)+1]=0;                  
              
       SHFILEOPSTRUCT shf;
       ZeroMemory(&shf, sizeof(SHFILEOPSTRUCT));
       shf.hwnd=NULL;
       shf.wFunc=FO_RENAME;
       shf.pFrom=source;
       shf.pTo=dest;
       shf.fFlags=BYTE(flag);
        if(SHFileOperation(&shf) == 0)
         _hi_onEvent(_event_onOK );
     }             
   
     HI_WORK_LOC(THIDirTools,_work_doExists) 
       {
           string d1 = ReadString(_Data,_data_Source,_prop_Source);
                   int i=0,i1=1,i2=2;
                   WIN32_FIND_DATA FileData; 
                 HANDLE hSearch;
              hSearch = FindFirstFile (PChar(d1),&FileData);
          if (hSearch == INVALID_HANDLE_VALUE)
                   _hi_onEvent(_event_onOK,i);
          else  { if(FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
                    _hi_onEvent(_event_onOK,i1);
                else  _hi_onEvent(_event_onOK,i2);}
                CloseHandle(hSearch);   
        } 
        
    HI_WORK_LOC(THIDirTools,_work_doGetSize)
         {     
              string d1 = ReadString(_Data,_data_Source,_prop_Source);
                string Dr = d1+L"\\";
                hold=0;
                Search(Dr);
                 _hi_onEvent(_event_onOK,(long)hold);                    
         }         
};

///////////////////////////////////////////////////////////////////////

#define faReadOnly   0x00000001
#define faHidden     0x00000002
#define faSysFile    0x00000004
#define faVolumeID   0x00000008
#define faDirectory  0x00000010
#define faArchive    0x00000020
#define faAnyFile    0x0000003F

typedef struct
{    int Attr;
     int Size;
    string Name;
    int ExcludeAttr;
    HANDLE FindHandle;
    WIN32_FIND_DATA FindData;
}TSearchDir;

  void THIDirTools::AllowUnDo(bool Value)
    {   
          if(Value) 
         au = FOF_ALLOWUNDO;
    }
   void THIDirTools::NoConfirmation(bool Value)
    {   
          if(Value) 
        nc = FOF_NOCONFIRMATION;
    }
  void THIDirTools::NoConfirmMKDir(bool Value)
    {   
          if(Value) 
        ncm = FOF_NOCONFIRMMKDIR;
    }
  void THIDirTools::NoErrorUI(bool Value)
    {   
          if(Value) 
        ne = FOF_NOERRORUI;
    }
   void THIDirTools::RenameOnCollision(bool Value)
    {   
          if(Value) 
         rc = FOF_RENAMEONCOLLISION;
    }
   void THIDirTools::Silent(bool Value)
    {   
          if(Value) 
         sl = FOF_SILENT;
    }
   void THIDirTools::SimpleProgress(bool Value)
    {   
          if(Value) 
      sp = FOF_SIMPLEPROGRESS;
      flag = au|nc|ncm|ne|rc|sl|sp;
    } 
  
  void FindClose(TSearchDir &F)
{
  if( F.FindHandle != INVALID_HANDLE_VALUE )
    FindClose(F.FindHandle);
}

int FindMatchingFile(TSearchDir &F)
{
    FILETIME LocalFileTime;

    while( F.FindData.dwFileAttributes & F.ExcludeAttr )
     if( !FindNextFile(F.FindHandle, &F.FindData) )
       return GetLastError();
    FileTimeToLocalFileTime(&F.FindData.ftLastWriteTime, &LocalFileTime);
    F.Attr = F.FindData.dwFileAttributes;
    F.Name = F.FindData.cFileName;
    F.Size = F.FindData.nFileSizeLow;
    return 0;
}

#define faSpecial faHidden|faSysFile|faVolumeID|faDirectory

int FindFirst(string &Path,int Attr,TSearchDir &F)
{
  F.ExcludeAttr = !(Attr & faSpecial);
  F.FindHandle = FindFirstFile(PChar(Path), &F.FindData);
  if( F.FindHandle != INVALID_HANDLE_VALUE )
    return FindMatchingFile(F);
  else  return GetLastError();
}

int FindNext(TSearchDir &F)
{
  if( FindNextFile(F.FindHandle, &F.FindData) )
    return FindMatchingFile(F);
  else return GetLastError();
}

void THIDirTools::Search(string &Dir)
{
  TSearchDir SDir;
  DWORD n = FindFirst(Dir + _his("*.*"),faAnyFile,SDir);
  while ( n == 0 )
  {
     if( SDir.Name[0] != _his('.') )
      if( SDir.Attr & faDirectory )
      {
        Search(Dir + SDir.Name + _his("\\"));
      }
      else { GetFileSize((HANDLE)n,NULL); 
                hold += SDir.Size;
           }
     n = FindNext(SDir);
  }
  FindClose(SDir);
}         
   
#endif                    